"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createKashmirServices = exports.KashmirModule = void 0;
const langium_1 = require("langium");
const kashmir_scope_1 = require("./kashmir-scope");
const module_1 = require("./generated/module");
const kashmir_validator_1 = require("./kashmir-validator");
/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
exports.KashmirModule = {
    references: {
        ScopeComputation: (services) => new kashmir_scope_1.CustomScopeComputation(services)
    },
    validation: {
        KashmirValidator: () => new kashmir_validator_1.KashmirValidator()
    }
};
/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
function createKashmirServices(context) {
    const shared = (0, langium_1.inject)((0, langium_1.createDefaultSharedModule)(context), module_1.KashmirGeneratedSharedModule);
    const Kashmir = (0, langium_1.inject)((0, langium_1.createDefaultModule)({ shared }), module_1.KashmirGeneratedModule, exports.KashmirModule);
    shared.ServiceRegistry.register(Kashmir);
    (0, kashmir_validator_1.registerValidationChecks)(Kashmir);
    return { shared, Kashmir };
}
exports.createKashmirServices = createKashmirServices;
//# sourceMappingURL=kashmir-module.js.map